<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $page, $user, $conf, $template;

if (script_basename() == 'picture')
{
  if (isset($_GET['mv']))
  {
    global $page;

    $page['items'] = explode(',', $_GET['mv']);
    $page['rank_of'] = array_flip($page['items']);

    add_event_handler('picture_pictures_data', 'add_pwgs_param_to_url');
    function add_pwgs_param_to_url($picture)
    {
      global $conf;

      foreach ($picture as $key => $pic)
      {
        $picture[$key]['url'] = add_url_params($pic['url'], array('mv' => $_GET['mv']));
      }
      $picture['current']['name'] = l10n('most_visited_cat') . $conf['level_separator'] . $picture['current']['name'];

      return $picture;
    }
  }
  return false;
}

if (($datas['cat_display'] == 'wo_thumb' and !empty($page['items']))
  or ($datas['cat_display'] == 'w_thumb' and empty($page['items']) and isset($page['category']))
  or ($datas['cat_display'] == 'selected_cats' and isset($page['category']) and !in_array($page['category']['id'], $datas['cat_selection'])))
{
  return false;
}

$query = '
  SELECT DISTINCT (i.id)
    FROM '.IMAGES_TABLE.' as i
      INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON i.id = ic.image_id
      INNER JOIN '.CATEGORIES_TABLE.' AS c ON ic.category_id = c.id
    WHERE i.hit > 0';

if (isset($page['category']))
{
  $query .= '
        AND ( c.uppercats LIKE \''.$page['category']['uppercats'].',%\' OR c.id = '.$page['category']['id'].' )
  ';
}

$query .= get_sql_condition_FandF(array( 'visible_images' => 'i.id' ), 'AND').'
      ORDER BY i.hit DESC, i.file ASC
    LIMIT 0, '.$datas['nb_images'].'
  ;';

$pictures = array();
$selection = array_from_query($query, 'id');
 
if (count($selection) > 0)
{
  $rank_of = array_flip($selection);

  $query = '
SELECT *
  FROM '.IMAGES_TABLE.'
  WHERE id IN ('.implode(',', $selection).')
;';
  $result = pwg_query($query);
  while ($row = mysql_fetch_assoc($result))
  {
    $row['rank'] = $rank_of[ $row['id'] ];

    array_push($pictures, $row);
  }

  usort($pictures, 'rank_compare');
  unset($rank_of);
}

if (count($pictures) > 0)
{
  // define category slideshow url
  $row = reset($pictures);
  $page['cat_slideshow_url'] =
    add_url_params(
      duplicate_picture_url(
        array(
          'image_id' => $row['id'],
          'image_file' => $row['file']
        ),
        array('start')
      ),
      array('slideshow' =>
        (isset($_GET['slideshow']) ? $_GET['slideshow']
                                   : '' ))
    );

  if ($user['show_nb_comments'])
  {
    $query = '
SELECT image_id, COUNT(*) AS nb_comments
  FROM '.COMMENTS_TABLE.'
  WHERE validated = \'true\'
    AND image_id IN ('.implode(',', $selection).')
  GROUP BY image_id
;';
    $nb_comments_of = simple_hash_from_query($query, 'image_id', 'nb_comments');
  }

  // template thumbnail initialization
  $template->set_filenames( array( 'most_visited' => 'thumbnails.tpl',));

  trigger_action('loc_begin_index_thumbnails', $pictures);
  $tpl_thumbnails_var = array();

  foreach ($pictures as $row)
  {
    // link on picture.php page
    $url = duplicate_picture_url(
          array(
            'image_id' => $row['id'],
            'image_file' => $row['file']
          ),
          array('start')
        );

    $tpl_var =
      array(
        'ID'        => $row['id'],
        'TN_SRC'    => get_thumbnail_url($row),
        'TN_ALT'    => $row['file'],
        'TN_TITLE'  => get_thumbnail_title($row),
        'ICON_TS'   => get_icon($row['date_available']),
        'URL'       => add_url_params($url, array('mv' => implode(',',$selection))),

     /* Fields for template-extension usage */
        'FILE_PATH' => $row['path'],
        'FILE_POSTED' => $row['date_available'],
        'FILE_CREATED' => $row['date_creation'],
        'FILE_DESC' => $row['comment'],
        'FILE_AUTHOR' => $row['author'],
        'FILE_HIT' => $row['hit'],
        'FILE_SIZE' => $row['filesize'],
        'FILE_WIDTH' => $row['width'],
        'FILE_HEIGHT' => $row['height'],
        'FILE_METADATE' => $row['date_metadata_update'],
        'FILE_HAS_HD' => ($row['has_high'] and $user['enabled_high']=='true') ?
                  true:false, /* lack of include/functions_picture.inc.php */
      );

    if ($user['show_nb_hits'])
    {
      $tpl_var['NB_HITS'] = $row['hit'];
    }

    if ($conf['show_thumbnail_caption'])
    {// name of the picture
      if (isset($row['name']) and $row['name'] != '')
      {
        $name = $row['name'];
      }
      else
      {
        $name = str_replace('_', ' ', get_filename_wo_extension($row['file']));
      }

      switch ($page['section'])
      {
        case 'best_rated' :
        {
          $name = '('.$row['average_rate'].') '.$name;
          break;
        }
        case 'most_visited' :
        {
          if ( !$user['show_nb_hits']) {
            $name = '('.$row['hit'].') '.$name;
          }
          break;
        }
      }

      $tpl_var['NAME'] = $name;
    }

    if ( isset($nb_comments_of) )
    {
      $tpl_var['NB_COMMENTS'] = (int)@$nb_comments_of[$row['id']];
    }

    $tpl_thumbnails_var[] = $tpl_var;
  }

  $tpl_thumbnails_var = trigger_event('loc_end_index_thumbnails', $tpl_thumbnails_var, $pictures);
  $template->assign('thumbnails', $tpl_thumbnails_var);

  $block['CONTENT'] = $template->parse('most_visited', true);
}

?>